% Spectrum Calculation

function [Spci,f,Nhi]=spec(y,ns,Fs)
% The first element in X is the zero-frequency value (constant term).
% If the number of elements N is even element N/2+1 is the Nyquist fre-
% quency. If N is odd there is no Nyquist frequency.
%
% Select the part of X that corresponds to positive frequencies.
% Nhi is the highest positive frequency. 2 is the lowest (1 is the constant
% term)
%
if mod(ns,2)==0
     Nhi = ns/2+1;
else
     Nhi = (ns+1)/2;
 end


 f=Fs*(0:ns/2)/ns;

P=fft(y,ns);

Spci=P.*conj(P)/ns;