close all
clear all
clc
format long

%%% =======================================================================
%% Input
%%% =======================================================================
folder = 'C:\Users\dreng\OneDrive\Dokumenter\NTNU\Hst 2018\Integrated dynamic analysis of wind turbines\SIMA\CSC5MW\Initial\'; % folder 
% where the analysis was carried out
bodyNum = 1; % body number
motion = 1; %1 for surge, 3 for heave, 5 for pitch, 6 for yaw
FFT_tmax = 1200;%750 in surge, 400 in heave, 600 in pitch, 750 ; % maximum time for the damping calculations
%(reduce if motions have already died out) 
endRamp = 350.2; % 350.2 in surge, 200.2 in pitch %start time for decay test
wnForDampCoeff = 2*pi/83.67; %83.67 in surge, 25.23 in heave, 32.2 in pitch, 62.37 in yaw% natural frequency in rad/s for damping coefficient 
% calculation. The damping coefficient calculation will use the estimated 
% natural frequency if wnForDampCoeff ==0. 


%% Read the SIMO results
% Read the SIMO results text file to get the channel names and number
% of steps
[nchan, nts, dt, chanNames] = readSIMO_resultstext([folder '\resultssurge.txt']);
% Read the binary file
BB = read_simoresults([folder '\resultssurge.tda'],nts);
sizeBB = size(BB);
if (sizeBB(1)<nts || nts<1); disp('Unable to read SIMO results'); return; end;
% Determine which channels to read for the platform motions, wave
% elevation
[chanMotions, chanWave] = getchannelNumbers(chanNames,bodyNum);
if (chanMotions(1)<1 || chanWave<1); disp('Unable to read SIMO results'); return; end;
time_SIMO = BB(:,2);

% summarize data in matrix
PlatMotions = BB(:,chanMotions);
wave = BB(:,chanWave);

%%
t = time_SIMO;
v = PlatMotions(:,motion);

%  only consider time greater than 200 s
% this line can cause some problems! may need to modify
skippt = sum(t<endRamp);
endpt = sum(t<FFT_tmax);
[tp ind] = dat2tp([t(skippt:endpt) v(skippt:endpt)],0,'none');
% estimate the period based on the peaks and troughs
TT = 2*mean(tp(2:end-2,1)-tp(1:end-3,1))
wnHz = 1/TT
if wnForDampCoeff == 0
    wnForDampCoeff = wnHz*2*pi;
end

% Plot the time series and the peaks/troughs
f= figure;
set(f,'Position',[500 500 700 200])
plot(t,v)
hold on
plot(tp(1:end-1,1),tp(1:end-1,2),'k.')
xlabel('Time, s')
ylabel('Surge, m')

% compute the damping coefficients
[b1,b2] = damp_coeff(tp,t,v,wnForDampCoeff,FFT_tmax,endRamp); 



